/*
    * @name: vuescroll 4.5.14
    * @author: (c) 2018-2018 wangyi7099
    * @description: A reactive virtual scrollbar based on vue.js 2.X
    * @license: MIT
    * @GitHub: https://github.com/wangyi7099/vuescroll
    */
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}var Vue=_interopDefault(require("vue")),_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};function deepCopy(e,t){for(var i in t="object"===(void 0===t?"undefined":_typeof(t))&&t||{},e)t[i]="object"===_typeof(e[i])?deepCopy(e[i],t[i]={}):e[i];return t}function deepMerge(e,t){for(var i in t=t||{},e)"object"===_typeof(e[i])?void 0===t[i]?(t[i]={},deepCopy(e[i],t[i])):deepMerge(e[i],t[i]):void 0===t[i]&&(t[i]=e[i]);return t}function defineReactive(e,t,i,o){var s=null;(i[t]||"function"==typeof i)&&(o=o||t,"function"==typeof i&&(s=i),Object.defineProperty(e,t,{get:s||function(){return i[o]},configurable:!0}))}var scrollBarWidth=void 0;function getGutter(){if(Vue.prototype.$isServer)return 0;if(void 0!==scrollBarWidth)return scrollBarWidth;var e=document.createElement("div");e.style.visibility="hidden",e.style.width="100px",e.style.position="absolute",e.style.top="-9999px",document.body.appendChild(e);var t=e.offsetWidth;e.style.overflow="scroll";var i=document.createElement("div");i.style.width="100%",e.appendChild(i);var o=i.offsetWidth;return e.parentNode.removeChild(e),scrollBarWidth=t-o}var doneUtil={refreshDomStyle:!1,loadDomStyle:!1,hide:!1};function hideSystemBar(){if(!doneUtil.hide){doneUtil.hide=!0;var e=document.createElement("style");e.type="text/css",e.innerHTML=".vuescroll-panel::-webkit-scrollbar{width:0;height:0}",document.getElementsByTagName("HEAD").item(0).appendChild(e)}}var styleMap={};function createDomStyle(e){if(!doneUtil[e]){doneUtil[e]=!0;var t=document.createElement("style");t.type="text/css",t.innerHTML=styleMap[e],document.getElementsByTagName("HEAD").item(0).appendChild(t)}}function eventCenter(e,t,i){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3];"on"==(arguments.length>4&&void 0!==arguments[4]?arguments[4]:"on")?e.addEventListener(t,i,o):e.removeEventListener(t,i,o)}styleMap.refreshDomStyle="\n.vuescroll-refresh {\n    color: black;\n    height: 50px;\n    text-align: center;\n    font-size: 16px;\n    line-height: 50px;\n}\n.vuescroll-refresh svg {\n    margin-right: 10px;\n    width: 25px;\n    height: 25px;\n    vertical-align: sub;\n}\n.vuescroll-refresh svg path,\n.vuescroll-refresh svg rect{\nfill: #FF6700;\n}\n",styleMap.loadDomStyle="\n.vuescroll-load {\n    color: black;\n    height: 50px;\n    text-align: center;\n    font-size: 16px;\n    line-height: 50px;\n}\n.vuescroll-load svg {\n    margin-right: 10px;\n    width: 25px;\n    height: 25px;\n    vertical-align: sub;\n}\n.vuescroll-load svg path,\n.vuescroll-load svg rect{\nfill: #FF6700;\n}\n";var log=console;function listenResize(e,t){var i=document.createElement("object");return i.style.cssText="display: block; position: absolute; top: 0; left: 0; width: 100%; height: 100%; border: none; padding: 0; margin: 0; opacity: 0; z-index: -1000; pointer-events: none;",i.tabIndex=-1,i.type="text/html",i.data="about:blank",i.isResizeElm=!0,i.onload=function(){eventCenter(i.contentDocument.defaultView,"resize",t)},e.appendChild(i),function(){i.contentDocument&&eventCenter(i.contentDocument.defaultView,"resize",t,"off"),e.removeChild(i)}}var modes=["slide","native","pure-native"],NOOP=function(){},uncessaryChangeArray=["mergedOptions.vuescroll.pullRefresh.tips","mergedOptions.vuescroll.pushLoad.tips","mergedOptions.rail","mergedOptions.bar"],GCF={vuescroll:{mode:"native",sizeStrategy:"percent",pullRefresh:{enable:!1,tips:{deactive:"Pull to Refresh",active:"Release to Refresh",start:"Refreshing...",beforeDeactive:"Refresh Successfully!"}},pushLoad:{enable:!1,tips:{deactive:"Push to Load",active:"Release to Load",start:"Loading...",beforeDeactive:"Load Successfully!"}},paging:!1,zooming:!0,snapping:{enable:!1,width:100,height:100},scroller:{bouncing:!0,locking:!0,minZoom:.5,maxZoom:3,speedMultiplier:1,penetrationDeceleration:.03,penetrationAcceleration:.08,preventDefault:!0}},scrollPanel:{initialScrollY:!1,initialScrollX:!1,scrollingX:!0,scrollingY:!0,speed:300,easing:void 0},scrollContent:{tag:"div",padding:!1,props:{},attrs:{}},rail:{vRail:{width:"5px",pos:"right",background:"#01a99a",opacity:0},hRail:{height:"5px",pos:"bottom",background:"#01a99a",opacity:0}},bar:{vBar:{background:"#00a650",deltaY:100,keepShow:!1,opacity:1,hover:!1},hBar:{background:"#00a650",keepShow:!1,opacity:1,hover:!1}}};function validateOptions(e){var t=!1,i=e.vuescroll,o=e.scrollPanel;~modes.indexOf(i.mode)||(console.error('[vuescroll]: The vuescroll\'s option "mode" should be one of the '+modes),t=!0),i.paging==i.snapping.enable&&i.paging&&(i.pullRefresh||i.pushLoad)&&console.error("[vuescroll][ops]: paging, snapping, (pullRefresh with pushLoad) can only one of them to be true.");var s=o.initialScrollY,r=o.initialScrollX;return s&&!String(s).match(/^\d+(\.\d+)?(%)?$/)&&console.error("[vuescroll][ops]: The prop `initialScrollY` should be a percent number like 10% or an exact number that greater than or equal to 0 like 100."),r&&!String(r).match(/^\d+(\.\d+)?(%)?$/)&&console.error("[vuescroll][ops]: The prop `initialScrollX` should be a percent number like 10% or an exact number that greater than or equal to 0 like 100."),t}function hackPropsData(){var e=this;if("vueScroll"===e.$options.name){var t=deepMerge(e.$vuescrollConfig,{}),i=deepMerge(GCF,t);e.$options.propsData.ops=e.$options.propsData.ops||{},Object.keys(e.$options.propsData.ops).forEach(function(t){defineReactive(e.mergedOptions,t,e.$options.propsData.ops)}),deepMerge(i,e.mergedOptions),defineReactive(e.mergedOptions.bar.vBar,"pos",e.mergedOptions.rail.vRail),defineReactive(e.mergedOptions.bar.vBar,"width",e.mergedOptions.rail.vRail),defineReactive(e.mergedOptions.bar.hBar,"pos",e.mergedOptions.rail.hRail),defineReactive(e.mergedOptions.bar.hBar,"height",e.mergedOptions.rail.hRail);defineReactive(e.mergedOptions.scrollContent,"paddPos",function(){return"padding-"+e.mergedOptions.rail.vRail.pos}),defineReactive(e.mergedOptions.scrollContent,"paddValue",function(){return e.mergedOptions.rail.vRail.width})}}var hackLifecycle={data:function(){return{shouldStopRender:!1,mergedOptions:{vuescroll:{},scrollPanel:{},scrollContent:{},rail:{},bar:{}}}},created:function(){hackPropsData.call(this),this.shouldStopRender=validateOptions(this.mergedOptions)}};function createEasingFunction(e,t){return function(i){return t(e,i)}}function easingPattern(e,t){var i=null;return"easeInQuad"===e&&(i=t*t),"easeOutQuad"===e&&(i=t*(2-t)),"easeInOutQuad"===e&&(i=t<.5?2*t*t:(4-2*t)*t-1),"easeInCubic"===e&&(i=t*t*t),"easeOutCubic"===e&&(i=--t*t*t+1),"easeInOutCubic"===e&&(i=t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1),"easeInQuart"===e&&(i=t*t*t*t),"easeOutQuart"===e&&(i=1- --t*t*t*t),"easeInOutQuart"===e&&(i=t<.5?8*t*t*t*t:1-8*--t*t*t*t),"easeInQuint"===e&&(i=t*t*t*t*t),"easeOutQuint"===e&&(i=1+--t*t*t*t*t),"easeInOutQuint"===e&&(i=t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t),i||t}function requestAnimationFrame(e){var t=e.requestAnimationFrame||e.webkitRequestAnimationFrame||e.mozRequestAnimationFrame||e.oRequestAnimationFrame,i=!!t;if(t&&!/requestAnimationFrame\(\)\s*\{\s*\[native code\]\s*\}/i.test(t.toString())&&(i=!1),i)return function(e,i){t(e,i)};var o={},s=1,r=null,l=+new Date;return function(e){var t=s++;return o[t]=e,requestCount++,null===r&&(r=setInterval(function(){var e=+new Date,t=o;for(var i in o={},requestCount=0,t)t.hasOwnProperty(i)&&(t[i](e),l=e);e-l>2500&&(clearInterval(r),r=null)},1e3/60)),t}}var time=Date.now||function(){return+new Date},desiredFrames=60,millisecondsPerSecond=1e3,running={},counter=1,core={effect:{}},global=null;function getNumericValue(e,t){var i=void 0;return i=(i=/(-?\d+(?:\.\d+?)?)%$/.exec(e))?t*(i=i[1]-0)/100:e-0}function goScrolling(e,t,i,o,s,r){var l=e.scrollTop,n=e.scrollLeft,a=n,c=l;l+i<0&&(i=-l),l+i>e.scrollHeight&&(i=e.scrollHeight-l),n+t<0&&(t=-n),n+t>e.scrollWidth&&(t=e.scrollWidth-n);var h=createEasingFunction(s,easingPattern),_=function(){return Math.abs(c-l)<Math.abs(i)||Math.abs(a-n)<Math.abs(t)};core.effect.Animate.start(function(o){return a=n+t*o,c=l+i*o,e.scrollTop=Math.floor(c),e.scrollLeft=Math.floor(a),_()},_,r,o,h)}global="undefined"!=typeof window?window:{},core.effect.Animate={requestAnimationFrame:requestAnimationFrame(global),stop:function(e){var t=null!=running[e];return t&&(running[e]=null),t},isRunning:function(e){return null!=running[e]},start:function(e,t,i,o,s,r){var l=time(),n=l,a=0,c=0,h=counter++;if(r||(r=document.body),h%20==0){var _={};for(var u in running)_[u]=!0;running=_}return running[h]=!0,core.effect.Animate.requestAnimationFrame(function _(u){var d=!0!==u,p=time();if(!running[h]||t&&!t(h))return running[h]=null,void(i&&i(desiredFrames-c/((p-l)/millisecondsPerSecond),h,!1));if(d)for(var f=Math.round((p-n)/(millisecondsPerSecond/desiredFrames))-1,m=0;m<Math.min(f,4);m++)_(!0),c++;o&&(a=(p-l)/o)>1&&(a=1);var v=s?s(a):a;!1!==e(v,p,d)&&1!==a||!d?d&&(n=p,core.effect.Animate.requestAnimationFrame(_,r)):(running[h]=null,i&&i(desiredFrames-c/((p-l)/millisecondsPerSecond),h,1===a||null==o))},r),h}};var api={methods:{scrollTo:function(e){var t=e.x,i=e.y,o=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],s=arguments.length>2&&void 0!==arguments[2]&&arguments[2];t=void 0===t?this.vuescroll.state.internalScrollLeft||0:getNumericValue(t,this.scrollPanelElm.scrollWidth),i=void 0===i?this.vuescroll.state.internalScrollTop||0:getNumericValue(i,this.scrollPanelElm.scrollHeight),this.internalScrollTo(t,i,o,s)},scrollBy:function(e){var t=e.dx,i=e.dy,o=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],s=this.vuescroll.state,r=s.internalScrollLeft,l=void 0===r?0:r,n=s.internalScrollTop,a=void 0===n?0:n;t&&(l+=getNumericValue(t,this.scrollPanelElm.scrollWidth)),i&&(a+=getNumericValue(i,this.scrollPanelElm.scrollHeight)),this.internalScrollTo(l,a,o)},zoomBy:function(e,t,i,o,s){"slide"==this.mode?this.scroller.zoomBy(e,t,i,o,s):log.warn("[vuescroll]: zoomBy and zoomTo are only for slide mode!")},zoomTo:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=arguments[2],o=arguments[3],s=arguments[4];"slide"==this.mode?this.scroller.zoomTo(e,t,i,o,s):log.warn("[vuescroll]: zoomBy and zoomTo are only for slide mode!")},getCurrentPage:function(){if("slide"==this.mode&&this.mergedOptions.vuescroll.paging)return this.scroller.getCurrentPage();log.warn("[vuescroll]: getCurrentPage and goToPage are only for slide mode and paging is enble!")},goToPage:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];"slide"==this.mode&&this.mergedOptions.vuescroll.paging?this.scroller.goToPage(e,t):log.warn("[vuescroll]: getCurrentPage and goToPage are only for slide mode and paging is enble!")},getCurrentviewDom:function(){for(var e=this,t=("slide"==this.mode||"pure-native"==this.mode?this.scrollPanelElm:this.scrollContentElm).children,i=[],o=function(t){var i=t.getBoundingClientRect(),o=i.left,s=i.top,r=i.width,l=i.height,n=e.$el.getBoundingClientRect(),a=n.left,c=n.top,h=n.height,_=n.width;return o-a+r>0&&o-a<_&&s-c+l>0&&s-c<h},s=0;s<t.length;s++){var r=t.item(s);o(r)&&!r.isResizeElm&&i.push(r)}return i},internalScrollTo:function(e,t,i,o){var s=this;if("native"==this.mode||"pure-native"==this.mode)if(i){goScrolling(this.$refs.scrollPanel.$el,e-this.$refs.scrollPanel.$el.scrollLeft,t-this.$refs.scrollPanel.$el.scrollTop,this.mergedOptions.scrollPanel.speed,this.mergedOptions.scrollPanel.easing,function(){s.update("handle-scroll-complete")})}else this.$refs.scrollPanel.$el.scrollTop=t,this.$refs.scrollPanel.$el.scrollLeft=e;else"slide"==this.mode&&this.scroller.scrollTo(e,t,i,void 0,o)}}},nativeMode={methods:{updateNativeModeBarState:function(){var e=this.scrollPanelElm,t=this.$el,i=100*t.clientHeight/e.scrollHeight,o=100*t.clientWidth/e.scrollWidth;this.bar.vBar.state.posValue=100*e.scrollTop/t.clientHeight,this.bar.hBar.state.posValue=100*e.scrollLeft/t.clientWidth,this.bar.vBar.state.size=i<100?i+"%":0,this.bar.hBar.state.size=o<100?o+"%":0}}},animatingMethod=null,noAnimatingMethod=null;function Scroller(e,t){for(var i in this.__callback=e,this.options={scrollingX:!0,scrollingY:!0,animating:!0,animationDuration:250,bouncing:!0,locking:!0,paging:!1,snapping:!1,zooming:!1,minZoom:.5,maxZoom:3,speedMultiplier:1,scrollingComplete:NOOP,animatingEasing:"easeOutCubic",noAnimatingEasing:"easeInOutCubic",penetrationDeceleration:.03,penetrationAcceleration:.08},t)this.options[i]=t[i];animatingMethod=createEasingFunction(this.options.animatingEasing,easingPattern),noAnimatingMethod=createEasingFunction(this.options.noAnimatingEasing,easingPattern)}var members={__isSingleTouch:!1,__isTracking:!1,__didDecelerationComplete:!1,__isGesturing:!1,__isDragging:!1,__isDecelerating:!1,__isAnimating:!1,__clientLeft:0,__clientTop:0,__clientWidth:0,__clientHeight:0,__contentWidth:0,__contentHeight:0,__snapWidth:100,__snapHeight:100,__refreshHeight:null,__loadHeight:null,__refreshActive:!1,__refreshActivate:null,__refreshBeforeDeactivate:null,__refreshDeactivate:null,__refreshStart:null,__loadActive:null,__loadActivate:null,__loadBeforeDeactivate:null,__loadDeactivate:null,__loadStart:null,__zoomLevel:1,__scrollLeft:0,__scrollTop:0,__maxScrollLeft:0,__maxScrollTop:0,__scheduledLeft:0,__scheduledTop:0,__scheduledZoom:0,__currentPageX:null,__currentPageY:null,__totalXPage:null,__totalYPage:null,__disable:!1,__lastTouchLeft:null,__lastTouchTop:null,__lastTouchMove:null,__positions:null,__minDecelerationScrollLeft:null,__minDecelerationScrollTop:null,__maxDecelerationScrollLeft:null,__maxDecelerationScrollTop:null,__decelerationVelocityX:null,__decelerationVelocityY:null,setDimensions:function(e,t,i,o){e===+e&&(this.__clientWidth=e),t===+t&&(this.__clientHeight=t),i===+i&&(this.__contentWidth=i),o===+o&&(this.__contentHeight=o),this.__computeScrollMax(),this.scrollTo(this.__scrollLeft,this.__scrollTop,!0)},setPosition:function(e,t){this.__clientLeft=e||0,this.__clientTop=t||0},setSnapSize:function(e,t){this.__snapWidth=e,this.__snapHeight=t},activatePullToRefresh:function(e,t){var i=t.activateCallback,o=t.deactivateCallback,s=t.startCallback,r=t.beforeDeactivateCallback;this.__refreshHeight=e,this.__refreshActivate=i,this.__refreshBeforeDeactivate=r,this.__refreshDeactivate=o,this.__refreshStart=s},activatePushToLoad:function(e,t){var i=t.activateCallback,o=t.deactivateCallback,s=t.startCallback,r=t.beforeDeactivateCallback;this.__loadHeight=e,this.__loadActivate=i,this.__loadBeforeDeactivate=r,this.__loadDeactivate=o,this.__loadStart=s},triggerRefreshOrLoad:function(){"refresh"==(arguments.length>0&&void 0!==arguments[0]?arguments[0]:"refresh")?(this.__publish(this.__scrollLeft,-this.__refreshHeight,this.__zoomLevel,!0),this.__refreshStart&&this.__refreshStart()):(this.__publish(this.__scrollLeft,this.__maxScrollTop+this.__loadHeight,this.__zoomLevel,!0),this.__loadStart&&this.__loadStart())},finishRefreshOrLoad:function(){var e=this;e.__refreshBeforeDeactivate&&e.__refreshActive?(e.__refreshActive=!1,e.__refreshBeforeDeactivate(function(){e.__refreshDeactivate&&e.__refreshDeactivate(),e.scrollTo(e.__scrollLeft,e.__scrollTop,!0)})):e.__refreshDeactivate&&e.__refreshActive&&(e.__refreshActive=!1,e.__refreshDeactivate(),e.scrollTo(e.__scrollLeft,e.__scrollTop,!0)),e.__loadBeforeDeactivate&&e.__loadActive?(e.__loadActive=!1,e.__loadBeforeDeactivate(function(){e.__loadDeactivate&&e.__loadDeactivate(),e.scrollTo(e.__scrollLeft,e.__scrollTop,!0)})):e.__loadDeactivate&&e.__loadActive&&(e.__loadActive=!1,e.__loadDeactivate(),e.scrollTo(e.__scrollLeft,e.__scrollTop,!0))},getValues:function(){return{left:this.__scrollLeft,top:this.__scrollTop,zoom:this.__zoomLevel}},getScrollMax:function(){return{left:this.__maxScrollLeft,top:this.__maxScrollTop}},zoomTo:function(e,t,i,o,s){if(!this.options.zooming)throw new Error("Zooming is not enabled!");s&&(this.__zoomComplete=s),this.__isDecelerating&&(core.effect.Animate.stop(this.__isDecelerating),this.__isDecelerating=!1);var r=this.__zoomLevel;null==i&&(i=this.__clientWidth/2),null==o&&(o=this.__clientHeight/2),e=Math.max(Math.min(e,this.options.maxZoom),this.options.minZoom),this.__computeScrollMax(e);var l=(i+this.__scrollLeft)*e/r-i,n=(o+this.__scrollTop)*e/r-o;l>this.__maxScrollLeft?l=this.__maxScrollLeft:l<0&&(l=0),n>this.__maxScrollTop?n=this.__maxScrollTop:n<0&&(n=0),this.__publish(l,n,e,t)},zoomBy:function(e,t,i,o,s){this.zoomTo(this.__zoomLevel*e,t,i,o,s)},scrollTo:function(e,t,i,o,s){if(this.__isDecelerating&&(core.effect.Animate.stop(this.__isDecelerating),this.__isDecelerating=!1),null!=o&&o!==this.__zoomLevel){if(!this.options.zooming)throw new Error("Zooming is not enabled!");e*=o,t*=o,this.__computeScrollMax(o)}else o=this.__zoomLevel;this.options.scrollingX||s?this.options.paging?e=Math.round(e/this.__clientWidth)*this.__clientWidth:this.options.snapping&&(e=Math.round(e/this.__snapWidth)*this.__snapWidth):e=this.__scrollLeft,this.options.scrollingY||s?this.options.paging?t=Math.round(t/this.__clientHeight)*this.__clientHeight:this.options.snapping&&(t=Math.round(t/this.__snapHeight)*this.__snapHeight):t=this.__scrollTop,e=Math.max(Math.min(this.__maxScrollLeft,e),0),t=Math.max(Math.min(this.__maxScrollTop,t),0),e===this.__scrollLeft&&t===this.__scrollTop&&(i=!1),this.__isTracking||this.__publish(e,t,o,i)},scrollBy:function(e,t,i){var o=this.__isAnimating?this.__scheduledLeft:this.__scrollLeft,s=this.__isAnimating?this.__scheduledTop:this.__scrollTop;this.scrollTo(o+(e||0),s+(t||0),i)},getCurrentPage:function(){return this.__computePage(),{x:this.__currentPageX,y:this.__currentPageY}},goToPage:function(e,t){this.scrollTo((e.x-1)*this.__clientWidth,(e.y-1)*this.__clientHeight,t)},doMouseZoom:function(e,t,i,o){var s=e>0?.97:1.03;return this.zoomTo(this.__zoomLevel*s,!1,i-this.__clientLeft,o-this.__clientTop)},doTouchStart:function(e,t){if(null==e.length)throw new Error("Invalid touch list: "+e);if(t instanceof Date&&(t=t.valueOf()),"number"!=typeof t)throw new Error("Invalid timestamp value: "+t);var i,o;this.__interruptedAnimation=!0,this.__isDecelerating&&(core.effect.Animate.stop(this.__isDecelerating),this.__isDecelerating=!1,this.__interruptedAnimation=!0),this.__isAnimating&&(core.effect.Animate.stop(this.__isAnimating),this.__isAnimating=!1,this.__interruptedAnimation=!0);var s=1===e.length;s?(i=e[0].pageX,o=e[0].pageY):(i=Math.abs(e[0].pageX+e[1].pageX)/2,o=Math.abs(e[0].pageY+e[1].pageY)/2),this.__initialTouchLeft=i,this.__initialTouchTop=o,this.__zoomLevelStart=this.__zoomLevel,this.__lastTouchLeft=i,this.__lastTouchTop=o,this.__lastTouchMove=t,this.__lastScale=1,this.__enableScrollX=!s&&this.options.scrollingX,this.__enableScrollY=!s&&this.options.scrollingY,this.__isTracking=!0,this.__didDecelerationComplete=!1,this.__isDragging=!s,this.__isSingleTouch=s,this.__positions=[]},doTouchMove:function(e,t,i){if(null==e.length)throw new Error("Invalid touch list: "+e);if(t instanceof Date&&(t=t.valueOf()),"number"!=typeof t)throw new Error("Invalid timestamp value: "+t);if(this.__isTracking){var o,s;2===e.length?(o=Math.abs(e[0].pageX+e[1].pageX)/2,s=Math.abs(e[0].pageY+e[1].pageY)/2):(o=e[0].pageX,s=e[0].pageY);var r=this.__positions;if(this.__isDragging){var l=o-this.__lastTouchLeft,n=s-this.__lastTouchTop,a=this.__scrollLeft,c=this.__scrollTop,h=this.__zoomLevel;if(null!=i&&this.options.zooming){var _=h;if(h=h/this.__lastScale*i,_!==(h=Math.max(Math.min(h,this.options.maxZoom),this.options.minZoom))){var u=o-this.__clientLeft,d=s-this.__clientTop;a=(u+a)*h/_-u,c=(d+c)*h/_-d,this.__computeScrollMax(h)}}if(this.__enableScrollX){a-=l*this.options.speedMultiplier;var p=this.__maxScrollLeft;(a>p||a<0)&&(this.options.bouncing?a+=l/2*this.options.speedMultiplier:a=a>p?p:0)}if(this.__enableScrollY){c-=n*this.options.speedMultiplier;var f=this.__maxScrollTop;(c>f||c<0)&&(this.options.bouncing?(c+=n/2*this.options.speedMultiplier,this.__enableScrollX||null==this.__refreshHeight&&null==this.__loadHeight||(!this.__refreshActive&&c<=-this.__refreshHeight?(this.__refreshActive=!0,this.__refreshActivate&&this.__refreshActivate()):this.__refreshActive&&c>-this.__refreshHeight?(this.__refreshActive=!1,this.__refreshDeactivate&&this.__refreshDeactivate()):!this.__loadActive&&c>=this.__maxScrollTop+this.__loadHeight?(this.__loadActive=!0,this.__loadActivate&&this.__loadActivate()):this.__refreshActive&&c<this.__maxScrollTop+this.__loadHeight&&(this.__loadActive=!1,this.__loadDeactivate&&this.__loadDeactivate()))):c=c>f?f:0)}r.length>60&&r.splice(0,30),r.push(a,c,t),this.__publish(a,c,h)}else{var m=this.options.locking?3:0,v=Math.abs(o-this.__initialTouchLeft),g=Math.abs(s-this.__initialTouchTop);this.__enableScrollX=this.options.scrollingX&&v>=m,this.__enableScrollY=this.options.scrollingY&&g>=m,r.push(this.__scrollLeft,this.__scrollTop,t),this.__isDragging=(this.__enableScrollX||this.__enableScrollY)&&(v>=5||g>=5),this.__isDragging&&(this.__interruptedAnimation=!1)}this.__lastTouchLeft=o,this.__lastTouchTop=s,this.__lastTouchMove=t,this.__lastScale=i}},doTouchEnd:function(e){if(e instanceof Date&&(e=e.valueOf()),"number"!=typeof e)throw new Error("Invalid timestamp value: "+e);if(this.__isTracking){if(this.__isTracking=!1,this.__isDragging)if(this.__isDragging=!1,this.__isSingleTouch&&this.options.animating&&e-this.__lastTouchMove<=100){for(var t=this.__positions,i=t.length-1,o=i,s=i;s>0&&t[s]>this.__lastTouchMove-100;s-=3)o=s;if(o!==i){var r=t[i]-t[o],l=this.__scrollLeft-t[o-2],n=this.__scrollTop-t[o-1];this.__decelerationVelocityX=l/r*(1e3/60),this.__decelerationVelocityY=n/r*(1e3/60);var a=this.options.paging||this.options.snapping?4:1;Math.abs(this.__decelerationVelocityX)>a||Math.abs(this.__decelerationVelocityY)>a?this.__refreshActive||this.__loadActive||this.__startDeceleration(e):this.__scrollComplete()}else this.__scrollComplete()}else e-this.__lastTouchMove>100&&this.__scrollComplete();this.__isDecelerating||(this.__refreshActive&&this.__refreshStart?(this.__publish(this.__scrollLeft,-this.__refreshHeight,this.__zoomLevel,!0),this.__refreshStart&&this.__refreshStart()):this.__loadActive&&this.__loadStart?(this.__publish(this.__scrollLeft,this.__maxScrollTop+this.__loadHeight,this.__zoomLevel,!0),this.__loadStart&&this.__loadStart()):((this.__interruptedAnimation||this.__isDragging)&&this.__scrollComplete(),this.scrollTo(this.__scrollLeft,this.__scrollTop,!0,this.__zoomLevel),this.__refreshActive?(this.__refreshActive=!1,this.__refreshDeactivate&&this.__refreshDeactivate()):this.__loadActive&&(this.__loadActive=!1,this.__loadDeactivate&&this.__loadDeactivate()))),this.__positions.length=0}},onScroll:NOOP,stop:function(){this.__disable=!0},start:function(){self.__disable=!0},__publish:function(e,t,i,o){var s=this;if(!s.__disable){var r=s.__isAnimating;if(r&&(core.effect.Animate.stop(r),s.__isAnimating=!1),o&&s.options.animating){s.__scheduledLeft=e,s.__scheduledTop=t,s.__scheduledZoom=i;var l=s.__scrollLeft,n=s.__scrollTop,a=s.__zoomLevel,c=e-l,h=t-n,_=i-a;s.__isAnimating=core.effect.Animate.start(function(e,t,i){i&&(s.__scrollLeft=l+c*e,s.__scrollTop=n+h*e,s.__zoomLevel=a+_*e,s.__callback&&(s.__callback(s.__scrollLeft,s.__scrollTop,s.__zoomLevel),s.onScroll()))},function(e){return s.__isAnimating===e},function(e,t,i){t===s.__isAnimating&&(s.__isAnimating=!1),(s.__didDecelerationComplete||i)&&s.__scrollComplete(),s.options.zooming&&(s.__computeScrollMax(),s.__zoomComplete&&(s.__zoomComplete(),s.__zoomComplete=null))},s.options.animationDuration,r?animatingMethod:noAnimatingMethod)}else s.__scheduledLeft=s.__scrollLeft=e,s.__scheduledTop=s.__scrollTop=t,s.__scheduledZoom=s.__zoomLevel=i,s.__callback&&(s.__callback(e,t,i),s.onScroll()),s.options.zooming&&(s.__computeScrollMax(),s.__zoomComplete&&(s.__zoomComplete(),s.__zoomComplete=null))}},__computeScrollMax:function(e){null==e&&(e=this.__zoomLevel),this.__maxScrollLeft=Math.max(this.__contentWidth*e-this.__clientWidth,0),this.__maxScrollTop=Math.max(this.__contentHeight*e-this.__clientHeight,0)},__computePage:function(){var e=this.__clientWidth,t=this.__clientHeight,i=this.__scrollLeft,o=this.__scrollTop;this.__totalXPage=Math.ceil(this.__contentWidth/e),this.__currentPageX=Math.ceil(i/e+1),this.__totalYPage=Math.ceil(this.__contentHeight/t),this.__currentPageY=Math.ceil(o/t+1)},__scrollComplete:function(){this.options.scrollingComplete()},__startDeceleration:function(){var e=this;if(e.options.paging){var t=Math.max(Math.min(e.__scrollLeft,e.__maxScrollLeft),0),i=Math.max(Math.min(e.__scrollTop,e.__maxScrollTop),0),o=e.__clientWidth,s=e.__clientHeight;e.__minDecelerationScrollLeft=Math.floor(t/o)*o,e.__minDecelerationScrollTop=Math.floor(i/s)*s,e.__maxDecelerationScrollLeft=Math.ceil(t/o)*o,e.__maxDecelerationScrollTop=Math.ceil(i/s)*s}else e.__minDecelerationScrollLeft=0,e.__minDecelerationScrollTop=0,e.__maxDecelerationScrollLeft=e.__maxScrollLeft,e.__maxDecelerationScrollTop=e.__maxScrollTop;var r=e.options.snapping?4:.001;e.__isDecelerating=core.effect.Animate.start(function(t,i,o){e.__stepThroughDeceleration(o)},function(){var t=Math.abs(e.__decelerationVelocityX)>=r||Math.abs(e.__decelerationVelocityY)>=r;return t||(e.__didDecelerationComplete=!0),t},function(){e.__isDecelerating=!1,e.__didDecelerationComplete&&e.__scrollComplete(),e.scrollTo(e.__scrollLeft,e.__scrollTop,e.options.snapping)})},__stepThroughDeceleration:function(e){var t=this.__scrollLeft+this.__decelerationVelocityX,i=this.__scrollTop+this.__decelerationVelocityY;if(!this.options.bouncing){var o=Math.max(Math.min(this.__maxDecelerationScrollLeft,t),this.__minDecelerationScrollLeft);o!==t&&(t=o,this.__decelerationVelocityX=0);var s=Math.max(Math.min(this.__maxDecelerationScrollTop,i),this.__minDecelerationScrollTop);s!==i&&(i=s,this.__decelerationVelocityY=0)}if(e?this.__publish(t,i,this.__zoomLevel):(this.__scrollLeft=t,this.__scrollTop=i),!this.options.paging){this.__decelerationVelocityX*=.95,this.__decelerationVelocityY*=.95}if(this.options.bouncing){var r=0,l=0,n=this.options.penetrationDeceleration,a=this.options.penetrationAcceleration;t<this.__minDecelerationScrollLeft?r=this.__minDecelerationScrollLeft-t:t>this.__maxDecelerationScrollLeft&&(r=this.__maxDecelerationScrollLeft-t),i<this.__minDecelerationScrollTop?l=this.__minDecelerationScrollTop-i:i>this.__maxDecelerationScrollTop&&(l=this.__maxDecelerationScrollTop-i),0!==r&&(r*this.__decelerationVelocityX<=0?this.__decelerationVelocityX+=r*n:this.__decelerationVelocityX=r*a),0!==l&&(l*this.__decelerationVelocityY<=0?this.__decelerationVelocityY+=l*n:this.__decelerationVelocityY=l*a)}}};for(var key in members)Scroller.prototype[key]=members[key];function _defineProperty(e,t,i){return t in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}function render(e,t,i,o){var s,r=document.documentElement.style,l=null,n=null;t.opera&&"[object Opera]"===Object.prototype.toString.call(opera)?s="presto":"MozAppearance"in r?s="gecko":"WebkitAppearance"in r?s="webkit":"string"==typeof navigator.cpuClass&&(s="trident"),"string"==typeof e&&(n="vertical"==e?(l=0)||o:(l=o)&&0);var a={trident:"ms",gecko:"Moz",webkit:"Webkit",presto:"O"}[s],c=document.createElement("div"),h=a+"Perspective",_=a+"Transform";return void 0!==c.style[h]?"string"==typeof e?_defineProperty({},_,"translate3d("+l+i+","+n+i+",0)"):function(t,o,s){e.style[_]="translate3d("+-t+i+","+-o+i+",0) scale("+s+")"}:void 0!==c.style[_]?"string"==typeof e?_defineProperty({},_,"translate("+l+i+","+n+i+")"):function(t,o,s){e.style[_]="translate("+-t+i+","+-o+i+") scale("+s+")"}:void 0}function listenContainer(e,t,i,o,s){var r=null;function l(e){e.touches[0]&&e.touches[0].target&&e.touches[0].target.tagName.match(/input|textarea|select/i)||(i("mousedown"),t.doTouchStart(e.touches,e.timeStamp),s&&e.preventDefault(),document.addEventListener("touchmove",n,{passive:!1}))}function n(e){i("mousemove"),t.doTouchMove(e.touches,e.timeStamp,e.scale),e.preventDefault()}function a(e){i("mouseup"),t.doTouchEnd(e.timeStamp),document.removeEventListener("touchmove",n)}function c(e){t.doTouchEnd(e.timeStamp)}function h(e){e.target.tagName.match(/input|textarea|select/i)||(i("mousedown"),t.doTouchStart([{pageX:e.pageX,pageY:e.pageY}],e.timeStamp),s&&e.preventDefault(),p=!0)}function _(e){p&&(i("mousemove"),t.doTouchMove([{pageX:e.pageX,pageY:e.pageY}],e.timeStamp),p=!0)}function u(e){p&&(i("mouseup"),t.doTouchEnd(e.timeStamp),p=!1)}function d(e){t.doMouseZoom(e.detail?-120*e.detail:e.wheelDelta,e.timeStamp,e.pageX,e.pageY)}if("ontouchstart"in window)e.addEventListener("touchstart",l,!1),document.addEventListener("touchend",a,!1),document.addEventListener("touchcancel",c,!1),r=function(){e.removeEventListener("touchstart",l,!1),document.removeEventListener("touchend",a,!1),document.removeEventListener("touchcancel",c,!1)};else{var p=!1;e.addEventListener("mousedown",h,!1),document.addEventListener("mousemove",_,!1),document.addEventListener("mouseup",u,!1),o&&e.addEventListener(navigator.userAgent.indexOf("Firefox")>-1?"DOMMouseScroll":"mousewheel",d,!1),r=function(){e.removeEventListener("mousedown",h,!1),document.removeEventListener("mousemove",_,!1),document.removeEventListener("mouseup",u,!1),e.removeEventListener(navigator.userAgent.indexOf("Firefox")>-1?"DOMMouseScroll":"mousewheel",d,!1)}}return t.onScroll=function(){i("onscroll")},r}var _extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var i=arguments[t];for(var o in i)Object.prototype.hasOwnProperty.call(i,o)&&(e[o]=i[o])}return e};function createStateCallbacks(e,t,i,o){var s=i.$listeners,r=function(){i.vuescroll.state[t]="active"},l=function(){i.vuescroll.state[t]="deactive"},n=function(){i.vuescroll.state[t]="start",setTimeout(function(){i.scroller.finishRefreshOrLoad()},2e3)},a=function(e){i.vuescroll.state[t]="beforeDeactive",setTimeout(function(){e()},500)};return s[e+"-activate"]&&(r=function(){i.vuescroll.state[t]="active",i.$emit(e+"-activate",i,o)}),s[e+"-before-deactivate"]&&(a=function(s){i.vuescroll.state[t]="beforeDeactive",i.$emit(e+"-before-deactivate",i,o,s.bind(i.scroller))}),s[e+"-deactivate"]&&(l=function(){i.vuescroll.state[t]="deactive",i.$emit(e+"-deactivate",i,o)}),s[e+"-start"]&&(n=function(){i.vuescroll.state[t]="start",i.$emit(e+"-start",i,o,i.scroller.finishRefreshOrLoad.bind(i.scroller))}),{activateCallback:r,deactivateCallback:l,startCallback:n,beforeDeactivateCallback:a}}var slideMode={methods:{updateScroller:function(){var e=this.$el.clientWidth,t=this.$el.clientHeight,i=this.scrollPanelElm.scrollWidth,o=this.scrollPanelElm.scrollHeight,s=0;if(this.mergedOptions.vuescroll.pullRefresh.enable){var r=this.$refs.refreshDom.elm||this.$refs.refreshDom;s=r.offsetHeight,r.style.marginTop||(r.style.marginTop=-s+"px",o-=s)}this.mergedOptions.vuescroll.pushLoad.enable&&(o-=(this.$refs.loadDom.elm||this.$refs.loadDom).offsetHeight);this.scroller.setDimensions(e,t,i,o)},registryScroller:function(){var e=this,t=this.mergedOptions.vuescroll.scroller.preventDefault,i=this.mergedOptions.vuescroll.paging,o=this.mergedOptions.vuescroll.snapping.enable,s=!this.refreshLoad&&!i&&!o&&this.mergedOptions.vuescroll.zooming,r=this.mergedOptions.scrollPanel,l=r.scrollingY,n=r.scrollingX;this.scroller=new Scroller(render(this.scrollPanelElm,window,"px"),_extends({},this.mergedOptions.vuescroll.scroller,{zooming:s,scrollingY:l,scrollingX:n&&!this.refreshLoad,animationDuration:this.mergedOptions.scrollPanel.speed,paging:i,snapping:o,scrollingComplete:function(){e.update("handle-scroll-complete")}})),o&&this.scroller.setSnapSize(this.mergedOptions.vuescroll.snapping.width,this.mergedOptions.vuescroll.snapping.height);var a=this.$el.getBoundingClientRect();this.scroller.setPosition(a.left+this.$el.clientLeft,a.top+this.$el.clientTop);var c=listenContainer(this.$el,this.scroller,function(t){switch(t){case"mousedown":e.vuescroll.state.isDragging=!0;break;case"onscroll":e.handleScroll(!1);break;case"mouseup":e.vuescroll.state.isDragging=!1}},s,t);return this.mergedOptions.vuescroll.pullRefresh.enable&&this.registryEvent("refresh"),this.mergedOptions.vuescroll.pushLoad.enable&&this.registryEvent("load"),this.updateScroller(),c},updateSlideModeBarState:function(){var e,t,i=this.$el,o=this.scroller,s=0,r=0,l=i.clientWidth,n=i.clientHeight,a=l+this.scroller.__maxScrollLeft,c=n+this.scroller.__maxScrollTop,h=l<a&&this.mergedOptions.scrollPanel.scrollingX,_=n<c&&this.mergedOptions.scrollPanel.scrollingY;h&&(o.__scrollLeft<0?s=-o.__scrollLeft:o.__scrollLeft>o.__maxScrollLeft&&(s=o.__scrollLeft-o.__maxScrollLeft)),_&&(o.__scrollTop<0?r=-o.__scrollTop:o.__scrollTop>o.__maxScrollTop&&(r=o.__scrollTop-o.__maxScrollTop)),e=100*n/(c+r),t=100*l/(a+s);var u=Math.min(Math.max(0,o.__scrollTop),o.__maxScrollTop),d=Math.min(Math.max(0,o.__scrollLeft),o.__maxScrollLeft);this.bar.vBar.state.posValue=100*(u+r)/i.clientHeight,this.bar.hBar.state.posValue=100*(d+s)/i.clientWidth,o.__scrollLeft<0&&(this.bar.hBar.state.posValue=0),o.__scrollTop<0&&(this.bar.vBar.state.posValue=0),this.bar.vBar.state.size=e<100?e+"%":0,this.bar.hBar.state.size=t<100?t+"%":0},registryEvent:function(e){var t="refresh"==e?"refreshDom":"loadDom",i="refresh"==e?this.scroller.activatePullToRefresh:this.scroller.activatePushToLoad,o="refresh"==e?"refreshStage":"loadStage",s=this.$refs[t].elm||this.$refs[t],r=createStateCallbacks(e,o,this,s),l=s.offsetHeight;i.bind(this.scroller)(l,r)}}},map={vertical:{bar:{size:"height",opsSize:"width",posName:"top",page:"pageY",scroll:"scrollTop",scrollSize:"scrollHeight",offset:"offsetHeight",client:"clientY"},axis:"Y"},horizontal:{bar:{size:"width",opsSize:"height",posName:"left",page:"pageX",scroll:"scrollLeft",scrollSize:"scrollWidth",offset:"offsetWidth",client:"clientX"},axis:"X"}},_extends$1=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var i=arguments[t];for(var o in i)Object.prototype.hasOwnProperty.call(i,o)&&(e[o]=i[o])}return e};function _defineProperty$1(e,t,i){return t in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}var bar={name:"bar",props:{ops:{type:Object,required:!0},state:{type:Object,required:!0},type:{type:String,required:!0}},computed:{bar:function(){return map[this.type].bar},axis:function(){return map[this.type].axis},parent:function(){return this.$parent.$refs}},render:function(e){var t,i=this,o={style:_extends$1((_defineProperty$1(t={},this.bar.posName,0),_defineProperty$1(t,this.ops.pos,0),_defineProperty$1(t,this.bar.size,this.state.size),_defineProperty$1(t,this.bar.opsSize,this.ops[this.bar.opsSize]),_defineProperty$1(t,"borderRadius",this.ops[this.bar.opsSize]),_defineProperty$1(t,"background",this.ops.background),_defineProperty$1(t,"opacity",this.state.opacity),_defineProperty$1(t,"cursor","pointer"),_defineProperty$1(t,"position","absolute"),_defineProperty$1(t,"transition","opacity .5s"),_defineProperty$1(t,"userSelect","none"),t),render(this.type,window,"%",this.state.posValue)),class:"vuescroll-"+this.type+"-scrollbar",on:{mousedown:this.handleMousedown}};return this.ops.hover&&(o.on.mouseenter=function(){i.$el.style.background=i.ops.hover},o.on.mouseleave=function(){i.$el.style.background=i.ops.background}),e("div",o)},methods:{handleMousedown:function(e){e.stopPropagation(),document.onselectstart=function(){return!1},this.axisStartPos=e[this.bar.client]-this.$el.getBoundingClientRect()[this.bar.posName],this.$emit("setBarClick",!0),eventCenter(document,"mousemove",this.handleMouseMove),eventCenter(document,"mouseup",this.handleMouseUp)},handleMouseMove:function(e){if(this.axisStartPos){var t=(e[this.bar.client]-this.parent[this.type+"Rail"].getBoundingClientRect()[this.bar.posName]-this.axisStartPos)/this.parent[this.type+"Rail"][this.bar.offset];this.$parent.scrollTo(_defineProperty$1({},this.axis.toLowerCase(),this.parent.scrollPanel.$el[this.bar.scrollSize]*t),!1)}},handleMouseUp:function(){this.$emit("setBarClick",!1),document.onselectstart=null,this.$parent.hideBar(),this.axisStartPos=0,eventCenter(document,"mousemove",this.handleMouseMove,"off"),eventCenter(document,"mouseup",this.handleMouseUp,"off")}}};function createBar(e,t,i){var o="vertical"===i?"vBar":"hBar",s="vertical"===i?"Y":"X",r={props:{type:i,ops:t.mergedOptions.bar[o],state:t.bar[o].state},on:{setBarClick:t.setBarClick},ref:i+"Bar"};return!t.bar[o].state.size||!t.mergedOptions.scrollPanel["scrolling"+s]||"pure-native"==t.mode||t.refreshLoad&&"vertical"!==i&&"slide"===t.mode?null:e("bar",r)}function _defineProperty$2(e,t,i){return t in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}function handleClickTrack(e,t,i,o,s){var r=t.client,l=t.offset,n=t.posName,a=t.scrollSize,c=i[o+"Bar"].$el[l],h=(e[r]-e.target.getBoundingClientRect()[n]-c/2)/e.target[l],_=i.scrollPanel.$el[a]*h;s.scrollTo(_defineProperty$2({},map[o].axis.toLowerCase(),_))}var rail={name:"rail",functional:!0,render:function(e,t){var i,o=t.parent,s=t.props,r=map[s.type].bar,l=o.$refs;return e("div",{style:(_defineProperty$2(i={},r.posName,0),_defineProperty$2(i,s.ops.pos,0),_defineProperty$2(i,r.size,"100%"),_defineProperty$2(i,r.opsSize,s.ops[r.opsSize]),_defineProperty$2(i,"borderRadius",s.ops[r.opsSize]),_defineProperty$2(i,"background",s.ops.background),_defineProperty$2(i,"opacity",s.ops.opacity),_defineProperty$2(i,"position","absolute"),_defineProperty$2(i,"cursor","pointer"),i),class:"vuescroll-"+s.type+"-rail",ref:s.type+"Rail",on:{click:function(e){handleClickTrack(e,r,l,s.type,o)}}},[" "])}};function createRail(e,t,i){var o="vertical"===i?"vRail":"hRail",s="vertical"===i?"vBar":"hBar",r="vertical"===i?"Y":"X",l={props:{type:i,ops:t.mergedOptions.rail[o],state:t.rail[o].state}};return!t.bar[s].state.size||"pure-native"==t.mode||!t.mergedOptions.scrollPanel["scrolling"+r]||t.refreshLoad&&"vertical"!==i&&"slide"===t.mode?null:e("rail",l)}var scrollContent={name:"scrollContent",functional:!0,props:{ops:{type:Object},state:{type:Object,default:function(){return{}}}},render:function(e,t){var i=t.props,o=t.slots,s=deepMerge(i.state.style,{});return s.position="relative",s.minHeight="100%",s.minWidth="100%",s.display="inline-block",s.boxSizing="border-box",i.ops.padding&&(s[i.ops.paddPos]=i.ops.paddValue),e(i.ops.tag,{style:s,ref:"scrollContent",class:"vuescroll-content",props:i.ops.props,attrs:i.ops.attrs},o().default)}};function createContent$1(e,t){return e("scrollContent",{props:{ops:t.mergedOptions.scrollContent}},[[t.$slots.default]])}var scrollPanel={name:"scrollPanel",props:{ops:{type:Object,required:!0}},methods:{updateInitialScroll:function(){var e=0,t=0;this.ops.initialScrollX&&(e=this.ops.initialScrollX),this.ops.initialScrollY&&(t=this.ops.initialScrollY),this.$parent.scrollTo({x:e,y:t})}},mounted:function(){var e=this;this.$nextTick(function(){e._isDestroyed||e.updateInitialScroll()})},render:function(e){return e("div",{class:["vuescroll-panel"]},[[this.$slots.default]])}};function createPanel(e,t){var i={ref:"scrollPanel",style:{position:"relative",height:"100%"},nativeOn:{scroll:t.handleScroll},props:{ops:t.mergedOptions.scrollPanel,state:t.scrollPanel.state}};if("native"==t.mode){t.mergedOptions.scrollPanel.scrollingY?i.style.overflowY=t.bar.vBar.state.size?"scroll":"":i.style.overflowY="hidden",t.mergedOptions.scrollPanel.scrollingX?i.style.overflowX=t.bar.hBar.state.size?"scroll":"":i.style.overflowX="hidden";var o=getGutter();o?(t.bar.vBar.state.size&&t.mergedOptions.scrollPanel.scrollingY&&(i.style.marginRight="-"+o+"px"),t.bar.hBar.state.size&&t.mergedOptions.scrollPanel.scrollingX&&(i.style.height="calc(100% + "+o+"px)")):(hideSystemBar(),i.style.height="100%"),i.style.transformOrigin="",i.style.transform=""}else"slide"==t.mode?(i.style.display="inline-block",i.style.transformOrigin="left top 0px",i.style.userSelect="none",i.style.height="",i.style["box-sizing"]="border-box"):"pure-native"==t.mode&&(i.style.width="100%",t.mergedOptions.scrollPanel.scrollingY?i.style.overflowY="auto":i.style.overflowY="hidden",t.mergedOptions.scrollPanel.scrollingX?i.style.overflowX="auto":i.style.overflowX="hidden");return e("scrollPanel",i,[createPanelChildren(t,e)])}function createPanelChildren(e,t){if("native"==e.mode)return[createContent$1(t,e)];if("slide"==e.mode){var i=[e.$slots.default];if(e.mergedOptions.vuescroll.pullRefresh.enable)if(e.$slots.refresh)e.$refs.refreshDom=e.$slots.refresh[0],i.unshift(e.$slots.refresh[0]);else{createDomStyle("refreshDomStyle");var o;o=createTipDom(t,e.vuescroll.state.refreshStage),i.unshift(t("div",{class:"vuescroll-refresh",ref:"refreshDom",key:"refshDom"},[[o,e.pullRefreshTip]]))}if(e.mergedOptions.vuescroll.pushLoad.enable)if(e.$slots.load)e.$refs.loadDom=e.$slots.load[0],i.push(e.$slots.load[0]);else{createDomStyle("loadDomStyle");var s;s=createTipDom(t,e.vuescroll.state.loadStage),i.push(t("div",{class:"vuescroll-load",ref:"loadDom",key:"loadDom"},[[s,e.pushLoadTip]]))}return i}return"pure-native"==e.mode?[e.$slots.default]:void 0}function createTipDom(e,t){var i=null;switch(t){case"deactive":i=e("svg",{attrs:{version:"1.1",xmlns:"http://www.w3.org/2000/svg",xmlnsXlink:"http://www.w3.org/1999/xlink",x:"0px",y:"0px",viewBox:"0 0 1000 1000","enable-background":"new 0 0 1000 1000",xmlSpace:"preserve"}},[e("metadata",[" Svg Vector Icons : http://www.sfont.cn "]),e("g",[e("g",{attrs:{transform:"matrix(1 0 0 -1 0 1008)"}},[e("path",{attrs:{d:"M10,543l490,455l490-455L885,438L570,735.5V18H430v717.5L115,438L10,543z"}})])])]);break;case"start":i=e("svg",{attrs:{version:"1.1",id:"loader-1",xmlns:"http://www.w3.org/2000/svg",xmlnsXlink:"http://www.w3.org/1999/xlink",x:"0px",y:"0px",viewBox:"0 0 50 50",xmlSpace:"preserve"},style:"enable-background:new 0 0 50 50;"},[e("path",{attrs:{fill:"#000",d:"M43.935,25.145c0-10.318-8.364-18.683-18.683-18.683c-10.318,0-18.683,8.365-18.683,18.683h4.068c0-8.071,6.543-14.615,14.615-14.615c8.072,0,14.615,6.543,14.615,14.615H43.935z"}},[e("animateTransform",{attrs:{attributeType:"xml",attributeName:"transform",type:"rotate",from:"0 25 25",to:"360 25 25",dur:"0.6s",repeatCount:"indefinite"}})])]);break;case"active":i=e("svg",{attrs:{version:"1.1",xmlns:"http://www.w3.org/2000/svg",xmlnsXlink:"http://www.w3.org/1999/xlink",x:"0px",y:"0px",viewBox:"0 0 1000 1000","enable-background":"new 0 0 1000 1000",xmlSpace:"preserve"}},[e("metadata",[" Svg Vector Icons : http://www.sfont.cn "]),e("g",[e("g",{attrs:{transform:"matrix(1 0 0 -1 0 1008)"}},[e("path",{attrs:{d:"M500,18L10,473l105,105l315-297.5V998h140V280.5L885,578l105-105L500,18z"}})])])])}return i}function findValuesByMode(e,t){var i={};switch(e){case"native":case"pure-native":i={x:t.scrollPanelElm.scrollLeft,y:t.scrollPanelElm.scrollTop};break;case"slide":i={x:t.scroller.__scrollLeft,y:t.scroller.__scrollTop}}return i}var vueScrollCore={name:"vueScroll",components:{bar:bar,rail:rail,scrollContent:scrollContent,scrollPanel:scrollPanel},props:{ops:{type:Object}},mixins:[hackLifecycle,api,nativeMode,slideMode],data:function(){return{vuescroll:{state:{isDragging:!1,isClickingBar:!1,pointerLeave:!0,timeoutId:0,internalScrollTop:0,internalScrollLeft:0,refreshStage:"deactive",loadStage:"deactive",height:"",width:""}},scrollPanel:{},scrollContent:{},rail:{vRail:{state:{}},hRail:{state:{}}},bar:{vBar:{state:{posValue:0,size:0,opacity:0}},hBar:{state:{posValue:0,size:0,opacity:0}},renderError:!1}}},render:function(e){var t=this;return t.renderError?[t.$slots.default]:e("div",{style:{position:"relative",height:t.vuescroll.state.height,width:t.vuescroll.state.width,padding:0,overflow:"hidden"},class:"vue-scroll",on:{mouseenter:function(){t.vuescroll.state.pointerLeave=!1,t.showBar()},mouseleave:function(){t.vuescroll.state.pointerLeave=!0,t.hideBar()},mousemove:function(){t.vuescroll.state.pointerLeave=!1,t.showBar()}}},[createPanel(e,t),createRail(e,t,"vertical"),createBar(e,t,"vertical"),createRail(e,t,"horizontal"),createBar(e,t,"horizontal")])},computed:{scrollPanelElm:function(){return this.$refs.scrollPanel.$el},scrollContentElm:function(){return this.$refs.scrollContent._isVue?this.$refs.scrollContent.$el:this.$refs.scrollContent},mode:function(){return this.mergedOptions.vuescroll.mode},pullRefreshTip:function(){return this.mergedOptions.vuescroll.pullRefresh.tips[this.vuescroll.state.refreshStage]},pushLoadTip:function(){return this.mergedOptions.vuescroll.pushLoad.tips[this.vuescroll.state.loadStage]},refreshLoad:function(){return this.mergedOptions.vuescroll.pullRefresh.enable||this.mergedOptions.vuescroll.pushLoad.enable}},methods:{update:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;"native"==this.mode||"pure-native"==this.mode?this.updateNativeModeBarState():"slide"==this.mode&&this.updateSlideModeBarState(),e&&this.emitEvent(e,t)},updateMode:function(){var e=this;if(this.shouldStop)this.$nextTick(function(){e.shouldStop=!1});else{var t=this.vuescroll.state.internalScrollLeft,i=this.vuescroll.state.internalScrollTop;this.destroyScroller&&(this.scroller.stop(),this.destroyScroller(),this.destroyScroller=null),"slide"==this.mode?this.destroyScroller=this.registryScroller():"native"!=this.mode&&"pure-native"!=this.mode||(this.scrollPanelElm.style.transform="",this.scrollPanelElm.style.transformOrigin=""),this.scrollTo({x:t,y:i},!1,!0)}},handleScroll:function(e){this.recordCurrentPos(),this.update("handle-scroll",e),this.showAndDefferedHideBar()},setBarClick:function(e){this.vuescroll.state.isClickingBar=e},showAndDefferedHideBar:function(){var e=this;this.showBar(),this.vuescroll.state.timeoutId&&clearTimeout(this.vuescroll.state.timeoutId),this.vuescroll.state.timeoutId=setTimeout(function(){e.vuescroll.state.timeoutId=0,e.hideBar()},500)},emitEvent:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,i=this.scrollPanelElm,o=i.scrollHeight,s=i.scrollWidth,r=i.clientHeight,l=i.clientWidth,n=i.scrollTop,a=i.scrollLeft,c={type:"vertical"},h={type:"horizontal"};"slide"==this.mode&&(n=this.scroller.__scrollTop,a=this.scroller.__scrollLeft,r=this.$el.clientHeight,l=this.$el.clientWidth),c.process=Math.min(n/(o-r),1),h.process=Math.min(a/(s-l),1),c.barSize=this.bar.vBar.state.size,h.barSize=this.bar.hBar.state.size,c.scrollTop=n,h.scrollLeft=a,this.$emit(e,c,h,t)},showBar:function(){this.bar.vBar.state.opacity=this.mergedOptions.bar.vBar.opacity,this.bar.hBar.state.opacity=this.mergedOptions.bar.hBar.opacity},hideBar:function(){this.vuescroll.state.isDragging||(this.mergedOptions.bar.vBar.keepShow||this.vuescroll.state.isClickingBar||!this.vuescroll.state.pointerLeave||(this.bar.vBar.state.opacity=0),this.mergedOptions.bar.hBar.keepShow||this.vuescroll.state.isClickingBar||!this.vuescroll.state.pointerLeave||(this.bar.hBar.state.opacity=0))},registryResize:function(){var e=this;if(this.shouldStop)this.$nextTick(function(){e.shouldStop=!1});else{this.destroyResize&&this.destroyResize();var t=null;"slide"==this.mode||"pure-native"==this.mode?t=this.scrollPanelElm:"native"==this.mode&&(t=this.scrollContentElm);var i=function(){e.update(),e.showAndDefferedHideBar(),"slide"==e.mode&&e.updateScroller()};window.addEventListener("resize",i,!1);var o=listenResize(t,function(){var t={};"slide"==e.mode?(e.updateScroller(),t.width=e.scroller.__contentWidth,t.height=e.scroller.__contentHeight):"native"==e.mode&&(t.width=e.scrollPanelElm.scrollWidth,t.height=e.scrollPanelElm.scrollHeight),e.update("handle-resize",t),e.showAndDefferedHideBar()});this.destroyResize=function(){window.removeEventListener("resize",i,!1),o()}}},registryParentResize:function(){this.destroyParentDomResize=listenResize(this.$el.parentNode,this.useNumbericSize)},useNumbericSize:function(){var e=this.$el.parentNode,t=e.style.position;t&&"static"!=t||(this.$el.parentNode.style.position="relative"),this.vuescroll.state.height=e.clientHeight+"px",this.vuescroll.state.width=e.clientWidth+"px"},usePercentSize:function(){this.vuescroll.state.height="100%",this.vuescroll.state.width="100%"},setVsSize:function(){"number"==this.mergedOptions.vuescroll.sizeStrategy?(this.useNumbericSize(),this.registryParentResize()):"percent"==this.mergedOptions.vuescroll.sizeStrategy&&(this.destroyParentDomResize&&this.destroyParentDomResize(),this.usePercentSize())},recordCurrentPos:function(){var e=this.mode;this.mode!==this.lastMode&&(e=this.lastMode,this.lastMode=this.mode);var t=findValuesByMode(e,this);this.vuescroll.state.internalScrollLeft=t.x,this.vuescroll.state.internalScrollTop=t.y},initWatch:function(){var e=this,t={deep:!0,sync:!0};this.$watch("mergedOptions",function(){e.recordCurrentPos(),e.$nextTick(function(){e.registryResize(),e.updateMode()})},t),uncessaryChangeArray.forEach(function(i){e.$watch(i,function(){e.shouldStop=!0},t)})}},mounted:function(){var e=this;this._isDestroyed||this.renderError||("slide"==this.mode&&(this.destroyScroller=this.registryScroller()),this.lastMode=this.mode,this.registryResize(),this.initWatch(),this.setVsSize(),this.$nextTick(function(){e.update(),e.showAndDefferedHideBar()}))},updated:function(){var e=this;this.$nextTick(function(){e._isDestroyed||e.showAndDefferedHideBar()})},beforeDestroy:function(){this.destroyParentDomResize&&this.destroyParentDomResize(),this.destroyDomResize&&this.destroyDomResize()}},scroll={install:function(e){scroll.isInstalled?log.warn("You should not install the vuescroll again!"):(e.component(vueScrollCore.name,vueScrollCore),e.prototype.$vuescrollConfig=deepMerge(GCF,{}),scroll.isInstalled=!0,scroll.version="4.5.14")}};module.exports=scroll;